package com.flossom.common.core.domain.vo;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.flossom.common.core.domain.entity.SysDept;
import com.flossom.common.core.domain.entity.SysMenu;
import com.flossom.common.core.domain.entity.SysTag;
import com.flossom.common.core.domain.entity.WxScriptTemplate;

import java.io.Serializable;
import java.util.List;
import java.util.stream.Collectors;

/**
 * Treeselect树结构实体类
 *
 * @author flossom
 */
public class TreeSelect implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 节点ID
     */
    private Long id;

    /**
     * 节点名称
     */
    private String label;

    /**
     * 内容
     */
    private String content;

    /**
     * 子节点
     */
    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    private List<TreeSelect> children;

    public TreeSelect() {

    }

    public TreeSelect(SysDept dept) {
        this.id = dept.getDeptId();
        this.label = dept.getDeptName();
        this.children = dept.getChildren().stream().map(TreeSelect::new).collect(Collectors.toList());
    }

    public TreeSelect(SysMenu menu) {
        this.id = menu.getMenuId();
        this.label = menu.getMenuName();
        this.children = menu.getChildren().stream().map(TreeSelect::new).collect(Collectors.toList());
    }

    public TreeSelect(SysTag sysTag) {
        this.id = sysTag.getId();
        this.label = sysTag.getTagName();
        this.children = sysTag.getChildren().stream().map(TreeSelect::new).collect(Collectors.toList());
    }

    public TreeSelect(WxScriptTemplate wxScriptTemplate) {
        this.id = wxScriptTemplate.getId();
        if (wxScriptTemplate.getParentId() == 0) {
            this.label = wxScriptTemplate.getScriptName();
        } else {
            this.label = wxScriptTemplate.getTitile();
        }
        this.content = wxScriptTemplate.getContent();
        this.children = wxScriptTemplate.getScriptTemplateChildren().stream().map(TreeSelect::new).collect(Collectors.toList());
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public List<TreeSelect> getChildren() {
        return children;
    }

    public void setChildren(List<TreeSelect> children) {
        this.children = children;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }
}
